/*
	bit - convert images to bit planes

	Carl Crawford 
	Purdue University
	W. Lafayette, IN 47907

	October 1981
*/

#include <stdio.h>

char	ibuf[512];	/* input buffer */
char	obuf[64];	/* output buffer */
char	*ifn = "/dev/gr"; /* input file name */
char	*ofn;		/* output file name */
FILE	*ifd;		/* input file descriptor */
FILE	*ofd;		/* output file descriptor */
int	x = 512;	/* x size of picture */
int	y = 480;	/* y size of picture */

char	*table[] = {
		"if",
		"of",
		"x",
		"y",
		0
	};

main(argc,argv)
	int	argc;
	char	**argv;
{
	char	c;
	char	tmp;
	int	i;
	register int j;
	register char *p,*q;

	while(++argv,--argc){
		if(**argv == '-')while(c = *++*argv)switch(c){

		default:
			fprintf(stderr,"bad flag: -%c\n",c);
			exit(1);
		}else switch(comm(*argv)){
		
		case 1:		/* input file name */
			ifn = *argv+3;
			break;
		case 2:		/* output file name */
			ofn = *argv+3;
			break;
		case 3:		/* x */
			x = atoi(*argv + 2);
			break;
		case 4:		/* y */
			y = atoi(*argv + 2);
			break;
		}
	}

	if(x<1 || x>512)err("bad x","");
	if(y<1 || y>512)err("bad y","");

	if(ifn[0] == '-' && !ifn[1]){
		ifd = stdin;
	}else{
		if((ifd=fopen(ifn,"r")) == NULL){
			err("can't open: ",ifn);
		}
	}

	if(ofn){
		if((ofd=fopen(ofn,"w"))==NULL){
			err("can't create: ",ofn);
		}
	}else{
		ofd = stdout;
	}

	for(i=x;i<512;ibuf[i++]=0);

	for(i=0;i<y;i++){
		for(j=0;j<64;obuf[j++]=0);
		if(fread(ibuf,sizeof(*ibuf),x,ifd) != x){
			err("unexpected EOF","");
		}
		for(p=ibuf,q=obuf,j=0;j<x;j += 8){
			if(*p++ < 0)*q |= 0200;
			if(*p++ < 0)*q |= 0100;
			if(*p++ < 0)*q |= 0040;
			if(*p++ < 0)*q |= 0020;
			if(*p++ < 0)*q |= 0010;
			if(*p++ < 0)*q |= 0004;
			if(*p++ < 0)*q |= 0002;
			if(*p++ < 0)*q |= 0001;
			q++;
		}
		for(j=0;j<64;j += 2){
			tmp = obuf[j];
			obuf[j] = obuf[j+1];
			obuf[j+1] = tmp;
		}
		fwrite(obuf,sizeof(*obuf),64,ofd);
	}
	for(j=0;j<64;obuf[j++]=0);
	for(j=y;j<512;j++)fwrite(obuf,sizeof(*obuf),64,ofd);
}

comm(s)
	char	*s;
{
	register	int	i,j,r;

	for(i=0;table[i];i++){
		for(j=0;(r=table[i][j]) == s[j] && r;j++);
		if(r == 0 && s[j] == '=' && s[j+1] )return(i+1);
	}
	fprintf(stderr,"bad option: %s\n",s);
	exit(1);
	return(0);
}

err(s1,s2)
	char	*s1,*s2;
{
	fputs(s1,stderr);
	fputs(s2,stderr);
	fputc('\n',stderr);
	exit(1);
}
