#include	<stdio.h>

/*
	window - convolve image with square window

	carl crawford
	purdue university
	w. lafayette, in 47907

	march 2, 1980


	syntax: window [options]

	VARIABLES:
	if:	input file name					stdin
	of:	output file name				stdout
	n:	size of picture					64
	m:	size of window (must be even)			4
	back:	back ground vlaue for edge of picture		0

*/

FILE	*ifd;		/* input file descriptor */
FILE	*ofd;		/* output file descriptor */
char	*ifn;		/* name of input file */
char	*ofn;		/* name of output file */
int	uif;		/* 1=use input file name */
int	uof;		/* 1=use output file name */
int	n =	64;	/* size of picture */
int	m =	4;	/* size of window */
float	*buf;		/* internal picture buffer */
float	*pt[512];	/* buffer pointers */
float	*wp[512];	/* window pointers */
float	outbuf[512];	/* output buffer */
int	m2;		/* m squared */
int	new;		/* where to put new input data */
int	nmm2,nmm3;	/* start and stop places for window average */
float	back;		/* back ground value */
float	atof();

char	*table[] = {
		"if",
		"of",
		"n",
		"m",
		"back",
		0
	};

main(argc,argv)
	int	argc;
	char	**argv;
{
	int	l;
	register	i,j,k;
	char	cc;

	argc--;
	argv++;
	while(argc){
		if(**argv=='-' && argv[0][1])while(cc= *++*argv)switch(cc){
			default:
				fprintf(stderr,"bad flag: %c\n",cc);
				exit(1);
		}else switch(comm(*argv)){
			case 1:		/* if */
				ifn = *argv + 3;
				uif = 1;
				break;
			case 2:		/* of */
				ofn = *argv + 3;
				uof = 1;
				break;
			case 3:		/* n */
				n = atoi(*argv + 2);
				break;
			case 4:		/* m */
				m = atoi(*argv + 2);
				break;
			case 5:		/* back */
				back = atof(*argv + 5);
				break;
		}
		argc--;
		argv++;
	}

	if(uif){
		if((ifd = fopen(ifn,"r")) == NULL){
			fprintf(stderr,"can't open: %s\n",ifn);
			exit(1);
		}
	}else{
		ifd = stdin;
	}
	if(uof){
		if((ofd = fopen(ofn,"w")) == NULL){
			fprintf(stderr,"can't create: %s\n",ofn);
			exit(1);
		}
	}else{
		ofd = stdout;
	}
	if(n < 1 || n > 512){
		fprintf(stderr,"bad picture size\n");
		exit(1);
	}
	if(m < 1 || m > n){
		fprintf(stderr,"bad window size\n");
		exit(1);
	}
	if((buf = (float *)calloc(n*m,4)) == NULL){
		fprintf(stderr,"can't allocate space for picture\n");
		exit(1);
	}
	for(i=1,pt[0]=buf;i<m;i++){
		pt[i] = pt[i-1] + n;
	}

	m2 = m * m;
	nmm2 = m>>1;
	nmm3 = n - nmm2;
	for(i=0;i<n;outbuf[i++] = back);

	for(i=0;i<nmm2;i++){
		fwrite(outbuf,sizeof(float),n,ofd);
	}
	for(i=0;i<m;i++){
		input(i);
	}

	for(l=nmm2;l<nmm3;l++){	/* loop through picture */
		for(j=0;j<nmm2;outbuf[j++] = back);
		for(j=nmm2;j<nmm3;outbuf[j++] = 0.0);
		for(j=nmm3;j<n;outbuf[j++] = back);
		for(j=0;j<m;j++){
			wp[j] = pt[j];
		}
		for(j=nmm2;j<nmm3;j++){	/* loop through outbuf */
			for(i=0;i<m;i++){	/* window */
				for(k=0;k<m;k++){
					outbuf[j] += *(wp[i] + k);
				}
			}
			outbuf[j] /= m2;
			for(i=0;i<m;i++)wp[i]++;
		}
		fwrite(outbuf,sizeof(float),n,ofd);
		input(new);
		new = (++new) % m;
	}
	for(i=0;i<n;outbuf[i++] = back);
	for(i=0;i<nmm2;i++){
		fwrite(outbuf,sizeof(float),n,ofd);
	}
}

input(i)
	int	i;
{
	if( fread(pt[i],sizeof(float),n,ifd ) != n){
		fprintf(stderr,"unexpected eof\n");
		exit(1);
	}
}

comm(s)
	char	*s;
{
	register	int	i,j,r;

	for(i=0;table[i];i++){
		for(j=0;(r=table[i][j]) == s[j] && r;j++);
		if(r == 0 && s[j] == '=' && s[j+1] )return(i+1);
	}
	fprintf(stderr,"bad option: %s\n",s);
	exit(1);
}
